unit uadd;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Controls, ExtCtrls, Forms, StdCtrls, ComCtrls, Process;


function UpdateFiles(ListBox: TListBox; TreeView: TTreeView; Edit: TEdit;
                              Process: TProcess; Command:String): Integer;


implementation

function UpdateFiles(ListBox: TListBox; TreeView: TTreeView; Edit: TEdit;
                              Process: TProcess; Command:String): Integer;
var
i, curlen: Integer;
filename, filetype, cur: string;
ProcessOutput : TStringList;
begin
  ProcessOutput := TStringList.Create;
  Process.CommandLine := Command + ' ls -Fa ' + Edit.Text;
  Process.Execute;
  ProcessOutput.LoadFromStream(Process.Output);
  for i := 0 to ProcessOutput.Count-1 do
  begin
       cur := ProcessOutput[i];
       curlen := length(cur);
       if (cur = './') or (cur = '../') then
       begin
            cur := copy(cur,1,curlen-1);
            ListBox.Items.Add(cur);
       end

       else
       begin

            if cur[curlen] = '/' then filetype := 'D'
               else if cur[curlen] = '@' then filetype := 'L'
                 else if cur[curlen] = '*' then filetype := 'E'
            else filetype := 'F';
            cur := copy(cur,1,curlen-1);
            ListBox.Items.Add('['+filetype+'] '+cur);
       end;

  end;
ProcessOutput.Free;
end;

end.

